#include "dcron.h"

Plugin::~Plugin() {
  // something here eh
}

void Plugin::entry(dev *devo) {
  d=devo;
  disp=d->getdisp();

  LoadConfig();
  Redraw(true);
  t=new timer(d, this, 60);
  d->event->addcb(this);
}

void Plugin::LoadConfig() {
ifstream fstr;
string filename, data;

  filename.assign(getenv("HOME"));
  filename.append("/.devolution/devo_conf");
  fstr.open(filename.c_str(), ios::in);

  CreateWindow();

  while(fstr) {
    fstr >> data;
    if(data=="dcronXY") {
      fstr >> gx >> gy >> gw >> gh;
      XMoveResizeWindow(disp, win, gx, gy, gw, gh);
    }
    if(data=="dcronBG") {
      fstr >> data;
      image=Imlib_load_image(d->dat, (char*)data.c_str());
      Imlib_apply_image(d->dat, image, win);
    }
    if(data=="dcronFormat") {
      getline(fstr, data);
      format=data.substr(1, data.find(1, '\n'));
    }
    if(data=="dcronFontXY") fstr >> tx >> ty;
  } fstr.close();  

}

void Plugin::CreateWindow() {
XSetWindowAttributes xswa;

  xswa.override_redirect=True;
  xswa.event_mask=SubstructureRedirectMask|SubstructureNotifyMask|ExposureMask;
  win=XCreateWindow(disp, *d->getroot(), 0, 0, 1, 1, 0, CopyFromParent, InputOutput, CopyFromParent, CWOverrideRedirect|CWEventMask, &xswa);
  xftdraw=XftDrawCreate(disp, (Drawable) win, DefaultVisual(disp, DefaultScreen(disp)), DefaultColormap(disp, DefaultScreen(disp)));
  XMapRaised(disp, win);
}

void Plugin::Redraw(bool clear) {
time_t ttmp=time(NULL);
struct tm *tt=localtime(&ttmp);
XftChar8 buff[1024];

  strftime((char*)buff, 1024, format.c_str(), tt);
  if(clear) XClearWindow(disp, win);
  XftDrawString8(xftdraw, &d->ffg, d->font, tx, ty+d->font->ascent, buff, strlen((char*)buff));
}

void Plugin::timeout() {
  Redraw(true);
}

void Plugin::cb_xevent(XEvent *ev) {
  if(ev && ev->type==Expose && ev->xexpose.window==win) {
    Redraw(false);
  }
}

