#ifndef callback_h
#define callback_h
#include "devolution.h"

class cb_base {
public:
  virtual void cb_string(string data) {} // general callbacks
  virtual void cb_xevent(XEvent *ev) {}
  virtual void timeout() {} // timer specific
};

class cb_timer {
public:
  timeval tv;
  int interval;
  cb_timer(cb_base *cbb, int intv) {
    gettimeofday(&tv, 0);
    tv.tv_sec+=intv;
    next=last=None;
    interval=intv;
    callback=cbb;
  }
  cb_timer *next, *last;
  cb_base *callback;
};

class cb_wrapper {
public:
  cb_wrapper(cb_base *cbb) {
    next=last=None;
    callback=cbb;
  }
  cb_wrapper *next, *last;
  cb_base *callback;
};

#endif
