#include "conf.h"

conf::conf(dev *devo) {
string filename, line;
ifstream fstr;
d=devo;
disp=d->getdisp();

  rootB1=rootB2=rootB3=None;
  filename.assign(getenv("HOME"));
  filename.append("/.devolution/devo_conf");
  fstr.open(filename.c_str(), ios::in);
  if(!fstr) { create(filename); fstr.open(filename.c_str(), ios::in); }

  while(fstr) {
    getline(fstr ,line);
    parse(line);
  } fstr.close();

  //if(!d->font) d->font=XftFontOpenXlfd(disp, DefaultScreen(disp), "fixed");
}


void conf::parse(string line) {
string data;

  if(line.substr(0, 10)=="LoadModule") {
    data=line.substr(11, line.find(11, '\n'));
    module *m; m=new module(d, data);
  }
  if(line.substr(0, 5)=="font=") {
    data=line.substr(5, line.find(5, '\n'));
    d->font=XftFontOpenXlfd(disp, DefaultScreen(disp), data.c_str());
    if(!d->font) cout << "[ can't  find font " << data << " ]" << endl;
  }
  if(line.substr(0, 7)=="fontfg=") makecolor(line.substr(7, line.find(7, '\n')));
  if(line.substr(0, 7)=="rootb1=") rootB1=new string(line.substr(7, line.find(7, '\n')));
  if(line.substr(0, 7)=="rootb2=") rootB2=new string(line.substr(7, line.find(7, '\n')));
  if(line.substr(0, 7)=="rootb3=") rootB3=new string(line.substr(7, line.find(7, '\n')));
  
}

void conf::create(string filename) {
string dir;
ofstream ostr;

  dir.assign("mkdir -p ");
  dir.append(getenv("HOME"));
  dir.append("/.devolution/");
  system(dir.c_str());

  ostr.open(filename.c_str(), ios::out);
  ostr << "; default devolution config" << endl << endl;
  ostr << ";LoadModule whatever.so" << endl << endl;
  ostr << "rootb1=xterm" << endl << "rootb2=xconsole" << endl << "rootb3=\\menu" << endl;
  cout << "no config file was found. i've created an empty one for you at " 
       << getenv("HOME") << "/.devolution/devo_conf... enjoy it :]" << endl;
}

void conf::makecolor(string color) {
XColor tmp1, tmp2;
  XAllocNamedColor(disp, DefaultColormap(disp, d->getscreen()), color.c_str(), &tmp1, &tmp2);
  d->ffg.color.red=tmp1.red;
  d->ffg.color.green=tmp1.green;
  d->ffg.color.blue=tmp1.blue;
  d->ffg.color.alpha=0xffff;
  d->ffg.pixel=tmp1.pixel;
}


