#include "devolution.h"


int d_xerror(Display *disp, XErrorEvent *e);

dev::dev(int argc, char **argv) {
XSetWindowAttributes xwa;
  if(!(disp=XOpenDisplay(NULL))) { cout << "cant open display :[\n"; exit(0); }

  XSetErrorHandler(d_xerror);
  screen=DefaultScreen(disp);

  root=DefaultRootWindow(disp);
  xwa.event_mask=ButtonPressMask|KeyPressMask|SubstructureRedirectMask|SubstructureNotifyMask;
  XChangeWindowAttributes(disp, root, CWEventMask, &xwa);
  XGrabKey(disp, XKeysymToKeycode(disp, XK_F1), Mod1Mask, root, True, GrabModeAsync, GrabModeAsync);
  XGrabKey(disp, XKeysymToKeycode(disp, XK_F2), Mod1Mask, root, True, GrabModeAsync, GrabModeAsync);
  XGrabKey(disp, XKeysymToKeycode(disp, XK_F3), Mod1Mask, root, True, GrabModeAsync, GrabModeAsync);

  head_frame=None;

  dat=Imlib_init(disp);

  event=new events(this);
  reg=new registry(this);
  config=new conf(this);
  intro=new splash(this);
  event->loop();
}


frame* dev::find(Window win) {
frame *f;

  for(f=head_frame; f; f=f->next) {
    if(f->frm==win || f->win==win) return f;
  }

return None;
}


int d_xerror(Display *disp, XErrorEvent *e) {
  if(e->error_code==BadAccess && e->request_code==X_ChangeWindowAttributes) {
    cout << endl << "\tcouldn't change root window attributes...\n\tmaybe another window manager is running?" << endl << endl;
    exit(1);
  }
  return 0;
}


