#include <dlfcn.h>

#include "dlc_server.h"
#include "dlc_maker_base.h"

//explicit
DLC_Maker_Base::DLC_Maker_Base (string Id)
  : Identity (Id)
  { Server.enter (Identity, this); }

DLC_Maker_Base::~DLC_Maker_Base ()
  { Server.remove (Identity); }


DLC_Server::~DLC_Server ()
  {
  for (DLLMap::iterator iter = DLLs.begin(); iter != DLLs.end(); iter++)
    {
    dlclose (iter->second);
    }
  }

bool DLC_Server::load_dll (const string &name)
  {
  if (DLLs.find (name) != DLLs.end())
    {
    cout << "load_dll: dll already registered." << endl;
    return false;
    }
  void *tmp = dlopen (name.c_str(), RTLD_NOW);
  if (!tmp) return false;
  DLLs[name] = tmp;
  return true;
  }

void DLC_Server::unload_dll (const string &name)
  {
  DLLMap::iterator iter = DLLs.find (name);
  if (iter == DLLs.end())
    {
    cout << "unload_dll: dll not registered." << endl;
    return;
    }
  dlclose (iter->second);
  DLLs.erase(iter);
  }

DLC_Base *DLC_Server::Get_Instance (const string &name)
  {
  ClassMap::const_iterator iter = Classes.find (name);
  if (iter == Classes.end()) return 0;
  return (iter->second)->Create();
  }

void DLC_Server::enter (const string &Id, const DLC_Maker_Base *const ptr)
  {
  if (Classes.find (Id) != Classes.end())
    {
    cout << "enter: class already registered." << endl;
    //return;
    }
  Classes[Id] = ptr;
  }

void DLC_Server::remove (const string &Id)
  {
  ClassMap::iterator iter = Classes.find (Id);
  if (iter == Classes.end())
    {
    cout << "remove: class not registered." << endl;
    return;
    }
  Classes.erase (iter);
  }

DLC_Server Server;
