#ifndef DLC_SERVER_H
#define DLC_SERVER_H

using namespace std;
#include <iostream>
#include <string>
#include <map>

class DLC_Base;

class DLC_Server
  {
  friend class DLC_Maker_Base;

  private:
    typedef map<string, const DLC_Maker_Base * > ClassMap;
    typedef map<string, void * > DLLMap;

    ClassMap Classes;
    DLLMap DLLs;

    void enter (const string &Id, const DLC_Maker_Base *const ptr);
    void remove (const string &Id);

  public:
    ~DLC_Server();

    bool load_dll (const string &name);
    void unload_dll (const string &name);
    DLC_Base *Get_Instance (const string &name);
  };

template <class T> T* New (const string &name)
  {
  DLC_Base *tmp = Server.Get_Instance (name);
  T *tmp2 = dynamic_cast<T *> (tmp);
  if (tmp2) return tmp2;
  delete tmp; return 0;
  }

extern DLC_Server Server;

#endif
