#ifndef events_h
#define events_h
#include "devolution.h"

class dev;
class events;
class frame;
class timer;

class events {
private:
  dev *d;
  Display *disp;
  frame *active;
  cb_wrapper *callback;

  /* mouse.cc */
  void enter(XCrossingEvent *ev);
  void button(XEvent *ev);

  /* keyboard.cc */
  void key(XKeyPressedEvent *ev);

  /* misc.cc */
  void map(XMapRequestEvent *ev);
  void unmap(XUnmapEvent *ev);
  void destroy(XDestroyWindowEvent *ev);
  void expose(XExposeEvent *ev);
  void config(XConfigureRequestEvent *ev);
public:
  events(dev *devo);
  timer *tim;

  void scan(), loop();
  void addcb(cb_base *cbb), remcb(cb_base *cbb), 
       addtimer(cb_base *cbb, int interval), remtimer(cb_base *cbb);
};

#endif // events_h
