#ifndef frame_h
#define frame_h

#include "devolution.h"
#define FRAME_NORMAL 2
#define FRAME_BOTTOM 3
#define FRAME_RIGHT  4
#define FRAME_LEFT   5
#define FRAME_NONE   6

class dev;

typedef struct geometry {
  int x, y, w, h;
} geometry;

class frame {
private:
  dev *d;
  Display *disp;

  void create_frame(), link();
  bool shaped, shaded, maximized, minimized;

public:
  frame(dev *devo, Window w, int type);
  ~frame();

  void drag(XEvent *ev), resize(XEvent *ev), kill(bool destroy), setwin();
  bool dragging, resizing;
  int unmap;

  struct geometry geonorm, geodrag, geosize;
  Window win, frm;
  frame *next, *last;
  char *name;
};


#endif // frame_h
